/*

DSMPESERM Baseboard BSL implementation layer

	Diamond Systems Corporation Universal Driver
	Version 7.00


	http://www.diamondsystems.com

	(c) Copyright 2012 Diamond Systems Corporation. Use of this source code
	is subject to the terms of Diamond Systems' Software License Agreement.
	Diamond Systems provides no warranty of proper performance if this
	source code is modified.
*/

#include "DSMPESER4MSerialProtocolSelection.h"
#define INI_BUFSIZE 256
int ini_getstr(char *file, char *key, char *buf, int bufsize);
char file[50]= "Configuration.ini";

int main()
{
	
	int data=0,Protocol_3_4_ports=0,Protocol_1_2_ports=0,status=0,Slew_1_2_ports=0,Slew_3_4_ports=0;
	char buffer[500];
	
	printf("\nDSMPESER4M Protocol Selection Demo");
	
	if((status=DSE_MPE_SER4M_INIT())==-1)
	{
		return 0;
	}
    
	if((status=DSE_MPE_SER4M_WRITE( 0x93 , 0xC0))==-1)//setting direction as o/p for MPIO 0:5
	{
		return 0;
	}

	if ((status=ini_getstr( file, "PROTOCOL_FOR_PORTS_1_AND_2", buffer, 1024))==1)
	{
		printf("\nProtocol_1_2_ports not found in the Configuration.ini file, using Default: %s","RS232");
		Protocol_1_2_ports=2;
	}

	else 
	{
		sscanf ( buffer, "%d", &Protocol_1_2_ports );
		
	}
	

	if ((status=ini_getstr( file, "PROTOCOL_FOR_PORTS_3_AND_4", buffer, 1024))==1)
	{
		printf("\nProtocol_3_4_ports not found in the Configuration.ini file, using Default: %s","RS232");
		Protocol_3_4_ports=2;
	}
	else
	{
		sscanf ( buffer, "%d", &Protocol_3_4_ports );
		
	}

	data =( Protocol_3_4_ports<<2 )| Protocol_1_2_ports;

	if ((status=ini_getstr( file, "SLEW_RATE_FOR_PORTS_1_AND_2", buffer, 1024))==1)
	{
		printf("\nSlew_1_2_ports not found in the Configuration.ini file, using Default: %s","Low");
		Slew_1_2_ports=0;
	}
	else
	{
		sscanf ( buffer, "%d", &Slew_1_2_ports );
		
	}
	if ((status=ini_getstr( file, "SLEW_RATE_FOR_PORTS_3_AND_4", buffer, 1024))==1)
	{
		printf("\nSlew_3_4_ports not found in the Configuration.ini file, using Default: %s","Low");
		Slew_3_4_ports=0;
	}
	else
	{
		sscanf ( buffer, "%d", &Slew_3_4_ports );
		
	}
	data =(( Slew_3_4_ports<<5 )|( Slew_1_2_ports<<4))|data;
	
	if((status=DSE_MPE_SER4M_WRITE( 0x90 , data))==-1)  // writing data / mode selection [UARTS10_SEL0:1]
	{
		return 0;
	}

	DSE_MPE_SER4M_CLOSE();
	printf("\nDSMPESER4M Protocol Selection Demo Completed\n");
	return 0;
}

int ini_getstr(char *file, char *key, char *buf, int bufsize)
{
	FILE *fp;
	char line[INI_BUFSIZE];
	int i, j, keylen;

	fp = fopen(file, "r");
	
	if ( fp == NULL )
	{
		printf("\nConfiguration file open failed");	
		return -1;
	}
	keylen = strlen(key);

	
	while ( fgets(line, INI_BUFSIZE, fp) != NULL ) 
	{

		if ( line[0] == '#' )
			continue;

		
		if ( !strncasecmp(line, key, keylen) ) 
		{

			if ( line[keylen] != '=' )
				continue;

			
			for ( i = keylen; isspace(line[i]); i++ )
				

			
			if ( line[i] != '=' )
				break;

			
			for ( i++; isspace(line[i]); i++ )
				

			
			if ( line[i] == '\0' )
				break;

			
			for ( j = 0; line[i] != '\r' && line[i] != '\n' && line[i] != '\0' && j < (bufsize-1); i++, j++ )
				buf[j] = line[i];

			
			if ( j >= bufsize )
				break;

			
			buf[j] = '\0';

			fclose(fp);
			return 0;
		}
	}

	
	fclose(fp);
	return 1;
}
